/**
 * 
 * Hexadecimal class.
 * 
 * @author Nicolae Ciprian Mocanu
 *
 */

import java.awt.Component;
import java.awt.Panel;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Scanner;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class Hexadecimal {

	 int checkPos=0;
	 int flag=0;
		int offset=0;
	ArrayList<BytePattern> bytePatterns;

	/**
	 * the class hexadecimal contains a list of BytePattern objects
	 */
	
public Hexadecimal() {
	
		bytePatterns= new ArrayList<>();
		
	}

/**
 * I am calling this method always when I 'm reading the line and finding a pattern 
 * @param bite represent the object of the BytePattern class  
 * i add the object to the list of objects 
 * 
 *
 */

public void addPatternToArray(BytePattern bite) {
	bytePatterns.add(bite);
}



String line;
int totalLine=0;
JFileChooser fileChooser;
JPanel panel;
File file;
ArrayList<byte[]> pattern ;


/**
 * this is a method to convert a hex string to byte
 * @param hex represents the hex to convert
 * @return a byte
 */
public  byte toByteFromHex(String hex)
{
	
	 long x=Long.parseLong(hex,16);
	 byte rc=(byte)x;
	
	
	return rc;
}


/**
 * i am using this method to read the file and get all the BytePattern objects
 * 
 * 
 */

	
	public void savePatterns() throws IOException
	{
	
					JFileChooser fileChooser = new JFileChooser();
					
					fileChooser.setCurrentDirectory(new File("c:\\temp"));
					
					
					int returnValue2=fileChooser.showOpenDialog(panel);
					if(returnValue2 == JFileChooser.APPROVE_OPTION)
					{
						file=fileChooser.getSelectedFile();
						 BufferedReader reader = null;
						try {
							reader = new BufferedReader(new FileReader(file));
						} 
						catch (FileNotFoundException e2) {
							
							e2.printStackTrace();
						}
						
						 
						try {
							line = reader.readLine();
						} catch (IOException e2) {
							
							e2.printStackTrace();
						}
						
						
						while(line !=null)
						{
							/**
							*a if the line is not null
							 *  split the line by spaces and store to @param splitLine
							 * convert each element of the string array into byte and store to @param newPattern
							 * create an object of the BytePattern using the @param newPattern found
							 * add each object to the arraylist
							 */
							
							try {
							
							 String[] splitLine = line.split(" ");
							 byte[] newPattern= new byte[splitLine.length];
							 for(int t =0 ; t<splitLine.length;t++)
								{ 
									
									splitLine[t]=splitLine[t].trim();
									
									//newPattern[t]=Integer.toHexString(splitLine[t] & 0xFF);
									 newPattern[t]=toByteFromHex(splitLine[t]);
									
								}
							 BytePattern obj1= new BytePattern(newPattern);
							 addPatternToArray(obj1);
							
								totalLine++;
								
								
							} catch(NumberFormatException s)
							{
								
							}
							
							
							
								
							try {
								line=reader.readLine();
							} catch (IOException e1) {
								
								e1.printStackTrace();
							}
							
							
							
							 }
					
					
						
						
						
						try {
							reader.close();
						} catch (IOException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
	}
					
	}			
				
						
						   
							
							
							
					}	
						
	
